## sipwitch 1.6.1

=== server/CMakeLists.txt ===
# Copyright (C) 2011 David Sugar, Tycho Softworks.
#
# This file is free software; as a special exception the author gives
# unlimited permission to copy and/or distribute it, with or without
# modifications, as long as this notice is preserved.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
#

set(server_src server.cpp registry.cpp stack.cpp thread.cpp call.cpp messages.cpp media.cpp system.cpp signals.cpp history.cpp protocols.cpp voip.cpp)
set(server_inc server.h voip.h)

if(NOT HAVE_PLUGINS)
    set(server_src ${server_src} forward.cpp scripting.cpp)
endif()

add_executable(sipwitch ${server_src} ${server_inc})
add_dependencies(sipwitch sipwitch-runtime usecure ucommon eXosip2)
target_link_libraries(sipwitch sipwitch-runtime usecure ucommon ${EXOSIP2_LIBS} ${SECURE_LIBS} ${UCOMMON_LIBS})
set_target_properties(sipwitch PROPERTIES OUTPUT_NAME sipw)
install(TARGETS sipwitch DESTINATION ${INSTALL_SBINDIR})

if(HAVE_PLUGINS)
    add_library(sipwitch-forward MODULE forward.cpp)
    add_dependencies(sipwitch-forward sipwitch-runtime ucommon)
    target_link_libraries(sipwitch-forward sipwitch-runtime ${USES_UCOMMON_LIBRARIES})
    set_target_properties(sipwitch-forward PROPERTIES OUTPUT_NAME forward SUFFIX ${MODULE_EXT} PREFIX "")

    add_library(sipwitch-scripting MODULE scripting.cpp)
    add_dependencies(sipwitch-scripting sipwitch-runtime ucommon)
    target_link_libraries(sipwitch-scripting sipwitch-runtime ${USES_UCOMMON_LIBRARIES})
    set_target_properties(sipwitch-scripting PROPERTIES OUTPUT_NAME scripting SUFFIX ${MODULE_EXT} PREFIX "")

    add_library(sipwitch-subscriber MODULE subscriber.cpp)
    add_dependencies(sipwitch-subscriber sipwitch-runtime ucommon)
    target_link_libraries(sipwitch-subscriber sipwitch-runtime ucommon ${USES_UCOMMON_LIBRARIES})
    set_target_properties(sipwitch-subscriber PROPERTIES OUTPUT_NAME subscriber SUFFIX ${MODULE_EXT} PREFIX "")

    install(TARGETS sipwitch-forward sipwitch-scripting sipwitch-subscriber DESTINATION ${INSTALL_PLUGINS})
endif()

if(HAVE_PLUGINS AND USES_ZEROCONF_FOUND)
    add_library(sipwitch-zeroconf MODULE zeroconf.cpp)
    add_dependencies(sipwitch-zeroconf sipwitch-runtime ucommon)
    target_link_libraries(sipwitch-zeroconf sipwitch-runtime ${USES_ZEROCONF_LIBRARIES} ${USES_UCOMMON_LIBRARIES})
    set_target_properties(sipwitch-zeroconf PROPERTIES OUTPUT_NAME zeroconf SUFFIX ${MODULE_EXT} PREFIX "")

    install(TARGETS sipwitch-zeroconf DESTINATION ${INSTALL_PLUGINS})
endif()

=== debian/changelog ===
sipwitch (1.6.1-2build2) wily; urgency=medium

  * No-change rebuild against libucommon7v5

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 06 Aug 2015 21:44:54 +0000

sipwitch (1.6.1-2build1) wily; urgency=medium

  * No change rebuild for new ucommon soname

 -- Sebastien Bacher <seb128@ubuntu.com>  Thu, 23 Jul 2015 17:06:09 +0200

sipwitch (1.6.1-2) unstable; urgency=medium

  [ Jonas Smedegaard ]
  * Resolve major versions from upstream autotools (not
    changelog/hardcoded).
  * Fix have -dev package install pkgconfig file.
  * Modernize git-buildpackage config: Drop "git-" prefix.
  * Update copyright info:
    + Fix use SPDX shortname for X11 license.
      Thanks to Paul Richards Tagliamonte.
    + Extend coverage for myself.
  * Fix relax d-shlibs quirks to match any API versions.
  * Adjust CDBS hints to use current automake and autoconf.
    Build-depend on automake (not automake1.11).
    Tighten build-dependency on cdbs.
  * Have autotools add non-shipped autotools.
  * Have autotools force use pkg-config.
    Closes: bug#784231. Thanks to Jonathan Wiltshire.

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 04 May 2015 14:57:35 +0200

sipwitch (1.6.1-1) unstable; urgency=low

  [ upstream ]
  * New release.
    + ucommon abi 6 support.
    + drop switchview (moved to standalone package).
    + usage of new context aware intermediary voip functions.
    + fixes for official exosip2 4.0.
    + improved ssl configure check.

  [ Jonas Smedegaard ]
  * Fix copy-paste error in short descriptions.
    Closes: bug#679392, #679393. Thanks to Davide Prina.
  * Bump dephelper compatibility level to 8.
  * Update copyright file:
    + Fix use pseudo-comment section to obey silly restrictions of
      copyright format 1.0.
    + Drop Files sections for no longer shipped files.
    + Extend copyright coverage for autotools to include recent years.
    + Add git URL as alternate source.
  * Drop patch 1001: Not strictly necessary.
  * Update package relations:
    + Relax to build-depend unversioned on cdbs: Needed version
      satisfied even in oldstable.
    + Tighten build-dependency on libucommon-dev: Fixes FTBFS.
      Closes: bug#707450. Thanks to Lucas Nussbaum and Andrey
      Rahmatullin.
  * Add README.source emphasizing control.in file as *not* a
    show-stopper for contributions, referring to wiki page for details.
  * Bump standards-version to 3.9.4.
  * Use canonical hostname (anonscm.debian.org) in Vcs-Git URI.
  * Bump packaging license to GPL-3+, and extend copyrigt coverage for
    myself to include current year.
  * Have git-import-orig avoid .git-ignore files.
  * Stop tracking md5sum of upstream tarball.
  * Add d-shlibs override to resolve now unversioned libucommon-dev
    dependency.

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 01 Jul 2013 11:37:18 +0200

=== debian/control ===
Source: sipwitch
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Jonas Smedegaard <dr@jones.dk>
Build-Depends: cdbs (>= 0.4.123~),
 autotools-dev,
 devscripts,
 libtool,
 automake,
 autoconf,
 debhelper,
 dh-buildinfo,
 libucommon-dev (>= 6),
 libexosip2-dev,
 pkg-config,
 libavahi-client-dev,
 d-shlibs
Standards-Version: 3.9.4
Homepage: http://www.gnu.org/software/sipwitch/
Section: net
Vcs-Git: git://anonscm.debian.org/git/collab-maint/sipwitch
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/sipwitch.git

Package: sipwitch
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 adduser,
Recommends: cron,
 logrotate
Suggests: sipwitch-cgi
Description: secure peer-to-peer VoIP server for the SIP protocol
 GNU SIP Witch is a secure peer-to-peer VoIP server.  Calls can be made
 even behind NAT firewalls, and without needing a service provider.  SIP
 Witch can be used on the desktop to create bottom-up secure calling
 networks as a free software alternative to Skype.  SIP Witch can also
 be used as a stand-alone SIP-based office telephone server, or to
 create secure VoIP networks for an existing IP-PBX such as Asterisk,
 FreeSWITCH, or Yate.
 .
 This package contains the sipwitch daemon and related utilities.

Package: libsipwitch-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends},
 libsipwitch1 (= ${binary:Version}),
 ${devlibs:Depends},
Description: secure peer-to-peer SIP VoIP server - development files
 GNU SIP Witch is a secure peer-to-peer VoIP server.  Calls can be made
 even behind NAT firewalls, and without needing a service provider.  SIP
 Witch can be used on the desktop to create bottom-up secure calling
 networks as a free software alternative to Skype.  SIP Witch can also
 be used as a stand-alone SIP-based office telephone server, or to
 create secure VoIP networks for an existing IP-PBX such as Asterisk,
 FreeSWITCH, or Yate.
 .
 This package contains the development headers and static libraries.

Package: libsipwitch1-dbg
Architecture: any
Section: debug
Priority: extra
Depends: ${misc:Depends},
 libsipwitch1 (= ${binary:Version})
Description: secure peer-to-peer SIP VoIP server - debug symbols
 GNU SIP Witch is a secure peer-to-peer VoIP server.  Calls can be made
 even behind NAT firewalls, and without needing a service provider.  SIP
 Witch can be used on the desktop to create bottom-up secure calling
 networks as a free software alternative to Skype.  SIP Witch can also
 be used as a stand-alone SIP-based office telephone server, or to
 create secure VoIP networks for an existing IP-PBX such as Asterisk,
 FreeSWITCH, or Yate.
 .
 This package contains the debugging symbols.

Package: libsipwitch1
Section: libs
Architecture: any
Depends: ${misc:Depends},
 ${shlibs:Depends}
Suggests: sipwitch
Description: secure peer-to-peer SIP VoIP server - shared libraries
 GNU SIP Witch is a secure peer-to-peer VoIP server.  Calls can be made
 even behind NAT firewalls, and without needing a service provider.  SIP
 Witch can be used on the desktop to create bottom-up secure calling
 networks as a free software alternative to Skype.  SIP Witch can also
 be used as a stand-alone SIP-based office telephone server, or to
 create secure VoIP networks for an existing IP-PBX such as Asterisk,
 FreeSWITCH, or Yate.
 .
 This package contains the shared libraries.

Package: sipwitch-cgi
Architecture: any
Depends: ${misc:Depends},
 ${shlibs:Depends}
Recommends: sipwitch, apache2 | httpd-cgi
Description: secure peer-to-peer SIP VoIP server - CGI XML-RPC interface
 GNU SIP Witch is a secure peer-to-peer VoIP server.  Calls can be made
 even behind NAT firewalls, and without needing a service provider.  SIP
 Witch can be used on the desktop to create bottom-up secure calling
 networks as a free software alternative to Skype.  SIP Witch can also
 be used as a stand-alone SIP-based office telephone server, or to
 create secure VoIP networks for an existing IP-PBX such as Asterisk,
 FreeSWITCH, or Yate.
 .
 This package contains the CGI-based XML-RPC interface for managing a
 locally resident sipw daemon, including the  ability to collect
 statistics and call information, and to perform control operations.
 This is meant to support creation of  remote  management  applications
 for sipwitch, especially when sipw might be executed on a dedicated
 router.

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-
# Copyright © 2011-2013, 2015 Jonas Smedegaard <dr@jones.dk>
# Description: Main Debian packaging script for GNU SIP Witch
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# This needs to be declared/run before including CDBS snippets
stem = $(DEB_SOURCE_PACKAGE)
major := $(shell grep ^LT_VERSION= configure.ac | grep -o '[[:digit:]]*' | head -n 1)
pkg-lib = lib$(stem)$(major)
debian/control:: debian/control.in
DEB_PHONY_RULES += debian/control.in
debian/control.in::
	sed -e 's/__LIBPKGNAME__/$(pkg-lib)/g' <debian/control.in.in >debian/control.in

DEB_AUTO_UPDATE_LIBTOOL = pre
DEB_AUTO_UPDATE_AUTOCONF = ,
DEB_AUTO_UPDATE_AUTOHEADER = ,
DEB_AUTO_UPDATE_ACLOCAL = ,
DEB_AUTO_UPDATE_AUTOMAKE = ,
include /usr/share/cdbs/1/rules/upstream-tarball.mk
include /usr/share/cdbs/1/rules/utils.mk
include /usr/share/cdbs/1/class/autotools.mk
#include /usr/share/cdbs/1/class/cmake.mk
include /usr/share/cdbs/1/rules/debhelper.mk

pkg-bin = $(stem)
pkg-cgi = $(stem)-cgi
pkg-dev = $(libname)-dev
pkg-cgi = $(stem)-doc
libname = lib$(stem)
pkgconfigstems = $(libname)
ucommon-major := $(shell grep ^UCOMMON_REQUIRES= configure.ac | grep -o '[[:digit:]]*' | head -n 1)

DEB_UPSTREAM_URL = http://ftp.gnu.org/gnu/sipwitch

CDBS_BUILD_DEPENDS += , libucommon-dev (>= $(ucommon-major)), libexosip2-dev
CDBS_BUILD_DEPENDS += , pkg-config, libavahi-client-dev

DEB_MAKE_CHECK_TARGET = check

devbinfiles = sipwitch-config
binfiles = sippasswd sipquery sipwitch
sbinfiles = sipw
cgifiles = sipwitch-cgi
DEB_INSTALL_MANPAGES_$(pkg-dev) = $(patsubst %,debian/tmp/usr/share/man/man1/%.1,$(devbinfiles))
DEB_INSTALL_MANPAGES_$(pkg-bin) = $(patsubst %,debian/tmp/usr/share/man/man1/%.1,$(binfiles))
DEB_INSTALL_MANPAGES_$(pkg-bin) += $(patsubst %,debian/tmp/usr/share/man/man8/%.8,$(sbinfiles))
DEB_INSTALL_MANPAGES_$(pkg-cgi) = $(patsubst %,debian/tmp/usr/share/man/man8/%.8,$(cgifiles))
DEB_DH_INSTALL_ARGS_ALL = --autodest
DEB_DH_INSTALL_ARGS_$(pkg-dev) = $(addprefix usr/bin/,$(devbinfiles))
DEB_DH_INSTALL_ARGS_$(pkg-bin) = $(addprefix usr/bin/,$(binfiles))
DEB_DH_INSTALL_ARGS_$(pkg-bin) += $(addprefix usr/sbin/,$(sbinfiles))
DEB_DH_INSTALL_ARGS_$(pkg-bin) += usr/lib/sipwitch/*.so etc
DEB_DH_INSTALL_ARGS_$(pkg-cgi) = $(addprefix usr/bin/,$(cgifiles))
DEB_DH_INSTALL_ARGS_$(pkg-cgi) += usr/lib/cgi-bin/

# put aside upstream-shipped temp files during build but after copyright-check
makefiledirs = common inc inc/sipwitch server test utils
upstreamtmpfiles = Makefile.in $(addsuffix /Makefile.in,$(makefiledirs))
upstreamtmpfiles += aclocal.m4 autoconf/ltmain.sh configure sipwitch.spec
pre-build:: debian/stamp-upstreamtmpstuff
debian/stamp-upstreamtmpstuff: debian/stamp-copyright-check
	for file in $(upstreamtmpfiles); do \
		[ ! -e $$file ] || [ -e $$file.upstream ] || cp -a $$file $$file.upstream; \
	done
	touch $@
clean::
	for file in $(upstreamtmpfiles); do \
		[ ! -e $$file.upstream ] || mv -f $$file.upstream $$file; \
	done
	rm -f debian/stamp-upstreamtmpstuff

# Have autotools force use pkg-config
DEB_CONFIGURE_EXTRA_FLAGS += --with-pkg-config

# Have autotools add non-shipped autotools and cleanup again
DEB_AUTOMAKE_ARGS = --add-missing
clean::
	rm -rf m4
	rm -f autoconf/compile autoconf/test-driver

# TODO: Enable docs when sensible (i.e. not mainly doing illegal ../ucommon)
#DEB_INSTALL_DOCS_$(pkg-doc) += doc/html
#common-build-indep:: debian/stamp-docs
#debian/stamp-docs:
#	rm -rf doc
#	doxygen Doxyfile
#	touch $@
#clean::
#	rm -rf doc
#	rm -f debian/stamp-docs

# Re-install initscript with debhelper to add pre- and postinst routines
install/$(pkg-bin)::
	mv debian/tmp/etc/init.d/$(stem) debian/$(stem).init
clean::
	rm -f debian/$(stem).init

# Let d-shlibs calculate development package dependencies
#  and handle shared library install
CDBS_BUILD_DEPENDS += , d-shlibs
binary-post-install/$(pkg-lib):: debian/stamp-local-shlibs-$(libname)
debian/stamp-local-shlibs-$(libname): binary-install/$(pkg-lib)
	d-shlibmove --commit \
		--devunversioned \
		--exclude-la \
		--override 's/$(libname)[0-9]\+-dev/$(libname)-dev/' \
		--override 's/libucommon[0-9]\+-dev/libucommon-dev/' \
		--movedev "debian/tmp/usr/include/*" usr/include/ \
		$(patsubst %,--movedev debian/tmp/usr/lib/pkgconfig/%.pc usr/lib/pkgconfig,$(pkgconfigstems)) \
		$(patsubst %,--extralib debian/tmp/usr/lib/%.so,$(extralibnames)) \
		debian/tmp/usr/lib/$(libname).so
	touch $@
clean::
	rm -f debian/stamp-local-shlibs-$(libname)

## sipwitch 1.9.15

=== CMakeLists.txt ===
# Copyright (C) 2011-2014 David Sugar, Tycho Softworks.
# Copyright (C) 2015 Cherokees of Idaho.
#
# This file is free software; as a special exception the author gives
# unlimited permission to copy and/or distribute it, with or without
# modifications, as long as this notice is preserved.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
#

cmake_minimum_required(VERSION 2.6)
PROJECT(sipwitch)
set (VERSION 1.9.15)
set (USES_UCOMMON_REQUIRED 7.0.0)
if(POLICY CMP0046)
    cmake_policy(SET CMP0046 OLD)
endif()

INCLUDE(CheckIncludeFiles)
INCLUDE(CheckFunctionExists)
INCLUDE(FindPkgConfig)
INCLUDE(GNUInstallDirs)

set(MODULE_EXT "${CMAKE_SHARED_LIBRARY_SUFFIX}")
set(INSTALL_PLUGINS "${CMAKE_INSTALL_FULL_LIBDIR}/sipwitch")
if(NOT CMAKE_INSTALL_CGIBINDIR)
    set(CMAKE_INSTALL_CGIBINDIR "/srv/www/cgi-bin")
endif()

if(WIN32)
    set(MODULE_EXT ".dll")
else()
    set(MODULE_EXT ".so")
endif()

if (WIN32)
    # too broken to build dll's with const static members...
    option(BUILD_STATIC "Set to OFF to build shared libraries" ON)
    set(HAVE_SIGWAIT false)
    set(HAVE_SIGWAIT2 off CACHE BOOL "disable sigwait on windows" FORCE)
    MARK_AS_ADVANCED(FORCE HAVE_SIGWAIT2)
else()
    option(BUILD_STATIC "Set to ON to build static libraries" OFF)
    option(HAVE_SIGWAIT2 "Set to OFF to build with single argument" ON)
    MARK_AS_ADVANCED(HAVE_SIGWAIT2)

    set(HAVE_SIGWAIT true)
endif()

MESSAGE( STATUS "Configuring GNU sipwitch ${VERSION}...")

find_package(PkgConfig)
if (USES_UCOMMON_INCLUDE_DIRS)
    message(STATUS "  Using local ucommon dependency")
else()
    pkg_check_modules(USES_UCOMMON REQUIRED ucommon>=${USES_UCOMMON_REQUIRED})
endif()

pkg_check_modules(USES_ZEROCONF avahi-client>=0.3.0)

if(USES_ZEROCONF_FOUND)
    set(ZEROCONF_AVAHI true)
endif()

pkg_check_modules(USES_SYSTEMD libsystemd-daemon>=44)
if(USES_SYSTEMD_FOUND)
    set(HAVE_SYSTEMD true)
endif()

include_directories(${USES_UCOMMON_INCLUDE_DIRS} ${CMAKE_CURRENT_SOURCE_DIR}/inc ${WITH_INCLUDES})
link_directories(${USES_UCOMMON_LIBRARY_DIRS} ${WITH_LIBS})
add_definitions(${USES_UCOMMON_CFLAGS} ${WITH_CFLAGS})

if(USES_UCOMMON_CMAKE_MACROS)
	set(CMAKE_MODULE_PATH "${USES_UCOMMON_CMAKE_MACROS}")
elseif(EXISTS "${USES_UCOMMON_PREFIX}/share/ucommon/cmake")
	set(CMAKE_MODULE_PATH "${USES_UCOMMON_PREFIX}/share/ucommon/cmake")
else()
	set(CMAKE_MODULE_PATH "${CMAKE_INSTALL_FULL_DATADIR}/ucommon/cmake")
endif()

include(CapeConfig)
include(CapeMakeTargets)

# by default we build static libs for windows, shared libs for unix.
# we may also set this from a top level cmake or -DWITH_XX_LIBS

if(BUILD_STATIC)
    set(BUILD_LIBRARY_TYPE STATIC)
else()
    set(BUILD_LIBRARY_TYPE SHARED)
endif()

if(NOT BUILD_RUNTIME_TYPE)
    set(BUILD_RUNTIME_TYPE ${BUILD_LIBRARY_TYPE})
endif()

check_include_files(sys/resource.h HAVE_SYS_RESOURCE_H)
check_include_files(sys/inotify.h HAVE_SYS_INOTIFY_H)
check_include_files(syslog.h HAVE_SYSLOG_H)
check_include_files(net/if.h HAVE_NET_IF_H)
check_include_files(sys/sockio.h HAVE_SYS_SOCKIO_H)
check_include_files(ioctl.h HAVE_IOCTL_H)
check_include_files(pwd.h HAVE_PWD_H)
check_include_files(eXosip2/eXosip.h HAVE_EXOSIP2)

if(HAVE_EXOSIP2)
    check_include_files(openssl/ssl.h HAVE_OPENSSL)
else()
    message(ERROR "libeXosip2 required to build")
endif()

if(HAVE_OPENSSL)
    if(WIN32 AND NOT CYGWIN AND NOT MINGW)
        set (EXOSIP2_LIBS eXosip2 osip2 osipparser2 ssleay32 libeay32 gdi32)
    else()
        set (EXOSIP2_LIBS eXosip2 osip2 osipparser2 ssl crypto z)
    endif()
else()
    set(EXOSIP2_LIBS eXosip2 osip2 osipparser2)
endif()

check_include_files(resolv.h HAVE_RESOLV_H)
if(HAVE_RESOLV_H)
    set(EXOSIP2_LIBS ${EXOSIP2_LIBS} resolv)
endif()

if(WIN32 AND NOT CYGWIN)
    set(EXOSIP2_LIBS ${EXOSIP2_LIBS} iphlpapi dnsapi ws2_32 crypt32)
endif()

if(APPLE)
    find_library(CORE_FOUNDATION CoreFoundation)
    find_library(CORE_SERVICES CoreServices)
    find_library(APPLE_SECURITY Security)
    set(EXOSIP2_LIBS ${EXOSIP2_LIBS} ${APPLE_SECURITY} ${CORE_SERVICES} ${CORE_FOUNDATION})
endif()

check_function_exists(setrlimit HAVE_SETRLIMIT)
check_function_exists(setgroups HAVE_SETGROUPS)
check_function_exists(setpgrp HAVE_SETPGRP)
check_function_exists(getuid HAVE_GETUID)
check_function_exists(mkfifo HAVE_MKFIFO)
check_function_exists(symlink HAVE_SYMLINK)
check_function_exists(atexit HAVE_ATEXIT)

file(GLOB runtime_src common/*.cpp)
file(GLOB runtime_inc inc/sipwitch/*.h)
file(GLOB sipwitch_man1 utils/*.1)
file(GLOB sipwitch_man8 utils/*.8 server/*.8)
file(GLOB sipwitch_conf server/*.conf)
file(GLOB sipwitch_xml server/*.xml*)

STRING(COMPARE EQUAL "${BUILD_RUNTIME_TYPE}" "SHARED" HAVE_PLUGINS)

pc_flags(PKG_SIPWITCH_FLAGS ${EXOSIP2_FLAGS})
pc_libs(PKG_SIPWITCH_LIBS ${EXOSIP2_LIBS})

create_headers()
create_specfile()
create_scripts(noinst_scr PKGBUILD)
create_pcfiles(pc_files libsipwitch)

add_library(sipwitch ${BUILD_RUNTIME_TYPE} ${runtime_src} ${runtime_inc})
set_library_version(sipwitch)
set_source_dependencies(sipwitch ucommon)
target_link_libraries(sipwitch ${USES_UCOMMON_LIBRARIES} ${EXOSIP2_LIBS})
set_target_properties(sipwitch PROPERTIES OUTPUT_NAME sipwitch)

add_subdirectory(server)

add_executable(sipwitch-query utils/sipquery.cpp)
set_source_dependencies(sipwitch-query usecure ucommon eXosip2)
target_link_libraries(sipwitch-query usecure ucommon ${EXOSIP2_LIBS} ${USES_UCOMMON_LIBRARIES})
set_target_properties(sipwitch-query PROPERTIES OUTPUT_NAME sipquery)

install(TARGETS sipwitch-query DESTINATION ${CMAKE_INSTALL_BINDIR})

add_executable(sipwitch-cgi utils/cgiserver.cpp)
set_source_dependencies(sipwitch-cgi ucommon)
target_link_libraries(sipwitch-cgi ucommon ${USES_UCOMMON_LIBRARIES})
if(UNIX)
    set_target_properties(sipwitch-cgi PROPERTIES OUTPUT_NAME sipwitch.cgi)
endif()

add_executable(sipwitch-passwd utils/sippasswd.cpp)
set_source_dependencies(sipwitch-passwd usecure ucommon)
target_link_libraries(sipwitch-passwd usecure ucommon ${USES_UCOMMON_LIBRARIES})
set_target_properties(sipwitch-passwd PROPERTIES OUTPUT_NAME sippasswd)
if(UNIX)
    target_setuid_properties(sipwitch-passwd)
endif()

add_executable(sipwitch-control utils/sipcontrol.cpp)
set_source_dependencies(sipwitch-control usecure ucommon)
target_link_libraries(sipwitch-control usecure ucommon ${USES_UCOMMON_LIBRARIES})
set_target_properties(sipwitch-control PROPERTIES OUTPUT_NAME sipcontrol)

if(CMAKE_SYSTEM_NAME STREQUAL Linux)
    # in DEBIAN we would set this off, in opensuse/rpm based, on...
    option(SYSTEM_CONFIG "Set to ON to write system config" OFF)
    if(SYSTEM_CONFIG)
        if(NOT CMAKE_INSTALL_UNITDIR)
            set(CMAKE_INSTALL_UNITDIR lib/systemd/system)
        endif()
        file(GLOB sipwitch_log server/*.log)
        file(GLOB sipwitch_cron server/*.cron)
        file(GLOB sipwitch_def server/*.defaults)
        file(GLOB sipwitch_init server/*.service)
        install(FILES   ${sipwitch_log} DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/logrotate.d RENAME sipwitch)
        install(FILES   ${sipwitch_cron} DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/cron.hourly RENAME sipwitch)
        install(FILES   ${sipwitch_def} DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/default RENAME sipwitch)
        install(FILES   ${sipwitch_init} DESTINATION ${CMAKE_INSTALL_UNITDIR})
    endif()
endif()

install(FILES ${pc_files} DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

install(FILES   ${sipwitch_conf} DESTINATION ${CMAKE_INSTALL_SYSCONFDIR})
install(FILES   ${sipwitch_xml} DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/sipwitch.d)
install(FILES   ${sipwitch_man1} DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
install(FILES   ${sipwitch_man8} DESTINATION ${CMAKE_INSTALL_MANDIR}/man8)
install(FILES   ${runtime_inc}  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/sipwitch)
install(TARGETS sipwitch DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(TARGETS sipwitch-control DESTINATION ${CMAKE_INSTALL_BINDIR})
install(TARGETS sipwitch-cgi DESTINATION ${CMAKE_INSTALL_CGIBINDIR})

if(SYSTEM_SETUID)
    install(TARGETS sipwitch-passwd DESTINATION ${CMAKE_INSTALL_BINDIR} PERMISSIONS SETUID)
else()
    install(TARGETS sipwitch-passwd DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

add_make_lint_target()
add_make_uninstall_target()

=== debian/changelog ===
sipwitch (1.9.15-3) unstable; urgency=medium

  * Update symbols file.

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 24 Apr 2016 18:07:56 +0200

sipwitch (1.9.15-2) unstable; urgency=medium

  * Fix fail on testsuite failure when targeted non-experimental.
  * Update symbols file.

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 24 Apr 2016 15:00:50 +0200

sipwitch (1.9.15-1) unstable; urgency=medium

  [ upstream ]
  * New release(s).
    Closes: Bug#813646, #821785. Thanks to Ohm Base and Chris Lamb.

  [ Jonas Smedegaard ]
  * Update copyright info:
    + Extend coverage for upstream authors.
    + List upstream bug mail addresses (not main upstream author) as
      preferred contact.
  * Adjust parsing of ucommon major version.
  * Stop cleanup autools now shipped upstream.
  * Move packaging to Debian VoIP team.
  * Update watch file: Mention gbp in usage comment. Bump to version 4.
  * Update git-buildpackage config: Ignore any .git* file.
  * Drop CDBS get-orig-source target: Use "gbp import-orig --uscan"
    instead.
  * Declare compliance with Debian Policy 3.9.8.
  * Update package relations:
    + Tighten build-dependency on libucommon-dev.
    + Tighten build-dependency on d-shlibs: Needed for ucommon,
      sipwitch, exosip and osip quirks.
    + Build-depend on libsystemd-dev on linux.
  * Adjust for upstream changes:
    + Stop install sipwitch-config binary or man page.
    + Install sipcontrol (not sipwitch) binary and manpage.
  * Add patch 1001 to have initscript source LSB init-functions.
  * Print test-suite.log on testsuite failure, and don't have it fail
    build when targeted experimental.
  * Track symbols with pkgkde-gensymbols.
    Build-depend on pkg-kde-tools.
  * Fix put aside more upstream-shipped temp files during build.

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 21 Apr 2016 14:44:02 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: sipwitch
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Jonas Smedegaard <dr@jones.dk>
+Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
+Uploaders: Jonas Smedegaard <dr@jones.dk>
 Build-Depends: cdbs (>= 0.4.123~),
  autotools-dev,
  devscripts,
@@ -10,16 +10,19 @@
  autoconf,
  debhelper,
  dh-buildinfo,
- libucommon-dev (>= 6),
+ libucommon-dev (>= 7),
  libexosip2-dev,
  pkg-config,
  libavahi-client-dev,
- d-shlibs
-Standards-Version: 3.9.4
+ libsystemd-dev [linux-any],
+ dpkg-dev (>= 1.17.0),
+ pkg-kde-tools,
+ d-shlibs (>= 0.73~)
+Standards-Version: 3.9.8
 Homepage: http://www.gnu.org/software/sipwitch/
 Section: net
-Vcs-Git: git://anonscm.debian.org/git/collab-maint/sipwitch
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/sipwitch.git
+Vcs-Git: https://anonscm.debian.org/git/collab-maint/sipwitch
+Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/sipwitch.git
 
 Package: sipwitch
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -30,7 +30,6 @@
 DEB_AUTO_UPDATE_AUTOHEADER = ,
 DEB_AUTO_UPDATE_ACLOCAL = ,
 DEB_AUTO_UPDATE_AUTOMAKE = ,
-include /usr/share/cdbs/1/rules/upstream-tarball.mk
 include /usr/share/cdbs/1/rules/utils.mk
 include /usr/share/cdbs/1/class/autotools.mk
 #include /usr/share/cdbs/1/class/cmake.mk
@@ -42,25 +41,31 @@
 pkg-cgi = $(stem)-doc
 libname = lib$(stem)
 pkgconfigstems = $(libname)
-ucommon-major := $(shell grep ^UCOMMON_REQUIRES= configure.ac | grep -o '[[:digit:]]*' | head -n 1)
-
-DEB_UPSTREAM_URL = http://ftp.gnu.org/gnu/sipwitch
+ucommon-major := $(shell grep ^USES_UCOMMON_REQUIRED= configure.ac | grep -o '[[:digit:]]*' | head -n 1)
 
 CDBS_BUILD_DEPENDS += , libucommon-dev (>= $(ucommon-major)), libexosip2-dev
 CDBS_BUILD_DEPENDS += , pkg-config, libavahi-client-dev
+CDBS_BUILD_DEPENDS +=, libsystemd-dev [linux-any]
 
-DEB_MAKE_CHECK_TARGET = check
+# resolve if release is experimental
+CDBS_BUILD_DEPENDS +=, dpkg-dev (>= 1.17.0)
+EXP_RELEASE = $(filter experimental% UNRELEASED,\
+ $(shell dpkg-parsechangelog -S Distribution))
 
-devbinfiles = sipwitch-config
-binfiles = sippasswd sipquery sipwitch
+CDBS_BUILD_DEPENDS +=, pkg-kde-tools
+include /usr/share/pkg-kde-tools/makefiles/1/cdbs/symbolshelper.mk
+export DPKG_GENSYMBOLS_CHECK_LEVEL=$(if $(EXP_RELEASE),0,1)
+
+DEB_MAKE_CHECK_TARGET = check \
+ || { cat test/test-suite.log; $(if $(EXP_RELEASE),,false;) }
+
+binfiles = sippasswd sipquery sipcontrol
 sbinfiles = sipw
 cgifiles = sipwitch-cgi
-DEB_INSTALL_MANPAGES_$(pkg-dev) = $(patsubst %,debian/tmp/usr/share/man/man1/%.1,$(devbinfiles))
 DEB_INSTALL_MANPAGES_$(pkg-bin) = $(patsubst %,debian/tmp/usr/share/man/man1/%.1,$(binfiles))
 DEB_INSTALL_MANPAGES_$(pkg-bin) += $(patsubst %,debian/tmp/usr/share/man/man8/%.8,$(sbinfiles))
 DEB_INSTALL_MANPAGES_$(pkg-cgi) = $(patsubst %,debian/tmp/usr/share/man/man8/%.8,$(cgifiles))
 DEB_DH_INSTALL_ARGS_ALL = --autodest
-DEB_DH_INSTALL_ARGS_$(pkg-dev) = $(addprefix usr/bin/,$(devbinfiles))
 DEB_DH_INSTALL_ARGS_$(pkg-bin) = $(addprefix usr/bin/,$(binfiles))
 DEB_DH_INSTALL_ARGS_$(pkg-bin) += $(addprefix usr/sbin/,$(sbinfiles))
 DEB_DH_INSTALL_ARGS_$(pkg-bin) += usr/lib/sipwitch/*.so etc
@@ -71,6 +76,8 @@
 makefiledirs = common inc inc/sipwitch server test utils
 upstreamtmpfiles = Makefile.in $(addsuffix /Makefile.in,$(makefiledirs))
 upstreamtmpfiles += aclocal.m4 autoconf/ltmain.sh configure sipwitch.spec
+upstreamtmpfiles += autoconf/compile autoconf/depcomp autoconf/missing
+upstreamtmpfiles += sipwitch-config.h.in
 pre-build:: debian/stamp-upstreamtmpstuff
 debian/stamp-upstreamtmpstuff: debian/stamp-copyright-check
 	for file in $(upstreamtmpfiles); do \
@@ -90,7 +97,6 @@
 DEB_AUTOMAKE_ARGS = --add-missing
 clean::
 	rm -rf m4
-	rm -f autoconf/compile autoconf/test-driver
 
 # TODO: Enable docs when sensible (i.e. not mainly doing illegal ../ucommon)
 #DEB_INSTALL_DOCS_$(pkg-doc) += doc/html
@@ -111,14 +117,14 @@
 
 # Let d-shlibs calculate development package dependencies
 #  and handle shared library install
-CDBS_BUILD_DEPENDS += , d-shlibs
+#  * d-shlibs 0.68 needed for libsipwitch quirk
+#  * d-shlibs 0.73 needed for libucommon, libexosip and libosib quirks
+CDBS_BUILD_DEPENDS +=, d-shlibs (>= 0.73~)
 binary-post-install/$(pkg-lib):: debian/stamp-local-shlibs-$(libname)
 debian/stamp-local-shlibs-$(libname): binary-install/$(pkg-lib)
 	d-shlibmove --commit \
 		--devunversioned \
 		--exclude-la \
-		--override 's/$(libname)[0-9]\+-dev/$(libname)-dev/' \
-		--override 's/libucommon[0-9]\+-dev/libucommon-dev/' \
 		--movedev "debian/tmp/usr/include/*" usr/include/ \
 		$(patsubst %,--movedev debian/tmp/usr/lib/pkgconfig/%.pc usr/lib/pkgconfig,$(pkgconfigstems)) \
 		$(patsubst %,--extralib debian/tmp/usr/lib/%.so,$(extralibnames)) \

=== debian/watch ===
# run "uscan --report" to check or "gpb import-orig --uscan" to update
version=4
http://ftp.gnu.org/gnu/sipwitch/sipwitch-(\d.*)\.tar\.gz
